/*
 * @author Bobby Kramer, released under GPL v 2.0
 */
package ulamgraph;

import java.applet.Applet;
import java.awt.Color;
import java.awt.Container;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JRadioButton;

import org.nfunk.jep.JEP;

public class UlamGraph extends Applet {
	private final int BUTTON_LEFT_WIDTH = 600;

	private GraphNum graph;
	// SettingPage setting;
	private JRadioButton primes, eq1_b_radio, eq2_b_radio;
	private JButton resetButton, ComputeButton, eq1ColorButton, eq2ColorButton;
	private JButton zoomIn, zoomOut;
	private JButton time_inc;
	private TextField eqn1_expression, eq1_b_from, eq1_b_to;
	private TextField eqn2_expression, eq2_b_from, eq2_b_to;

	private TextField num_start_at;
	private JEP myParser;
	int prevStartNum; // used to see if there is a new start number

	public void init() {
		this.setLayout(null);
		this.setSize(780, 600);
		this.setBackground(Color.BLACK);
		addRightSide();
		setupComponents();

	}

	public void setupComponents() {
		graph = new GraphNum(19881);
		graph.setBounds(0, 0, graph.WIDTH, graph.HEIGHT);
		add(graph);
		myParser = new JEP();
		myParser.initFunTab(); // clear the contents of the function table
		myParser.setImplicitMul(true);

	}

	// if true, it will try to zoom out, if it cant go any further, then it
	// stops
	public void setZoom(boolean ZoomOut) {
		graph.ZoomOut(ZoomOut);
		repaint();
	}

	public void addRightSide() {
		// label for Instructions
		JLabel useOnceLabel = new JLabel("Use x or b(ie-x^2+b*x or x^3+x)");
		useOnceLabel.setBounds(BUTTON_LEFT_WIDTH, 0, 200, 30);
		add(useOnceLabel);

		setBackground(Color.GREEN);
		ComputeButton = new JButton("Compute!");
		ComputeButton.setBounds(BUTTON_LEFT_WIDTH, 550, 90, 30);
		add(ComputeButton);
		// show primes checkbox
		primes = new JRadioButton("Show Primes?");
		primes.setBounds(BUTTON_LEFT_WIDTH, 530, 120, 20);
		add(primes);
		primes.setSelected(true);
		// reset button
		resetButton = new JButton("Reset");
		resetButton.setBounds(BUTTON_LEFT_WIDTH + 90, 550, 90, 30);
		add(resetButton);
		// label for start number
		useOnceLabel = new JLabel("Starting Number(center):");
		useOnceLabel.setBounds(BUTTON_LEFT_WIDTH, 430, 200, 30);
		add(useOnceLabel);
		// draw input for statlocation
		num_start_at = new TextField(8);
		num_start_at.setBounds(BUTTON_LEFT_WIDTH, 460, 80, 20);
		num_start_at.setText("0");
		add(num_start_at);

		// zoom in/out functionality
		zoomIn = new JButton("+");
		zoomIn.setBounds(BUTTON_LEFT_WIDTH, 490, 45, 30);
		add(zoomIn);
		zoomOut = new JButton("-");
		zoomOut.setBounds(BUTTON_LEFT_WIDTH + 45, 490, 45, 30);
		add(zoomOut);

		time_inc = new JButton("+1 to start");
		time_inc.setBounds(BUTTON_LEFT_WIDTH + 80, 460, 120, 20);
		add(time_inc);
		addColorButtons();
		addEQ1Box();
		addEQ2Box();
		addActionListeners();// add the listeners to this..

	}

	private void addColorButtons() {
		// color buttons
		// expression color buttons
		eq1ColorButton = new JButton("Color");
		eq1ColorButton.setBounds(BUTTON_LEFT_WIDTH + 50, 22, 65, 30);
		add(eq1ColorButton);
		eq2ColorButton = new JButton("Color");
		eq2ColorButton.setBounds(BUTTON_LEFT_WIDTH + 50, 172, 65, 30);
		add(eq2ColorButton);
	}

	private void addEQ1Box() {
		// label for expression 1
		JLabel useOnceLabel = new JLabel("Expr. 1:");
		useOnceLabel.setBounds(BUTTON_LEFT_WIDTH, 20, 100, 30);
		add(useOnceLabel);
		// label for b increment
		useOnceLabel = new JLabel("From Number:");
		useOnceLabel.setBounds(BUTTON_LEFT_WIDTH, 105, 80, 30);
		add(useOnceLabel);
		// label for b increment
		useOnceLabel = new JLabel("To Number:");
		useOnceLabel.setBounds(BUTTON_LEFT_WIDTH, 135, 80, 30);
		add(useOnceLabel);
		// draw expression part
		eqn1_expression = new TextField(20);
		eqn1_expression.setBounds(BUTTON_LEFT_WIDTH, 50, 150, 20);
		add(eqn1_expression);
		// Radio button to see if they want to use the b var
		eq1_b_radio = new JRadioButton("Use b variable?");
		eq1_b_radio.setBounds(BUTTON_LEFT_WIDTH, 80, 150, 20);
		add(eq1_b_radio);
		eq1_b_radio.setSelected(false);
		// text feild for from increment
		eq1_b_from = new TextField(10);
		eq1_b_from.setBounds(BUTTON_LEFT_WIDTH + 85, 110, 50, 20);
		add(eq1_b_from);
		// text feild for from increment
		eq1_b_to = new TextField(10);
		eq1_b_to.setBounds(BUTTON_LEFT_WIDTH + 85, 140, 50, 20);
		add(eq1_b_to);
	}

	private void addEQ2Box() {
		// label for expression 1
		JLabel useOnceLabel = new JLabel("Expr. 2:");
		useOnceLabel.setBounds(BUTTON_LEFT_WIDTH, 170, 180, 30);
		add(useOnceLabel);
		// label for b increment
		useOnceLabel = new JLabel("From Number:");
		useOnceLabel.setBounds(BUTTON_LEFT_WIDTH, 255, 80, 30);
		add(useOnceLabel);
		// label for b increment
		useOnceLabel = new JLabel("To Number:");
		useOnceLabel.setBounds(BUTTON_LEFT_WIDTH, 285, 80, 30);
		add(useOnceLabel);
		// draw expression part
		eqn2_expression = new TextField(20);
		eqn2_expression.setBounds(BUTTON_LEFT_WIDTH, 200, 150, 20);
		add(eqn2_expression);
		// Radio button to see if they want to use the b var
		eq2_b_radio = new JRadioButton("Use b variable?");
		eq2_b_radio.setBounds(BUTTON_LEFT_WIDTH, 230, 150, 20);
		add(eq2_b_radio);
		eq2_b_radio.setSelected(false);
		// text feild for from increment
		eq2_b_from = new TextField(10);
		eq2_b_from.setBounds(BUTTON_LEFT_WIDTH + 85, 260, 50, 20);
		add(eq2_b_from);
		// text feild for from increment
		eq2_b_to = new TextField(10);
		eq2_b_to.setBounds(BUTTON_LEFT_WIDTH + 85, 290, 50, 20);
		add(eq2_b_to);
	}

	private void parseExpression() {
		myParser.initSymTab(); // clear the contents of the symbol table
		myParser.addVariable("x", 1);// add x to parser
		parseEQ1();
		parseEQ2();
	}

	public void parseEQ2() {
		Object result;
		int eq2_bFrom = 0;
		int eq2_bTo = 0;
		if (eqn2_expression.getText() == "") {// if no equation entered, go
												// back
			return;
		}
		if (eq2_b_radio.isSelected()) {
			myParser.addVariable("b", 1); // add b to parser..
			eq2_bFrom = Integer.parseInt(this.eq2_b_from.getText());
			eq2_bTo = Integer.parseInt(this.eq2_b_to.getText());
		}
		myParser.parseExpression(eqn2_expression.getText());

		for (int a = 1; a < graph.getNodeCount(); a++) {
			myParser.addVariable("x", (double) a);
			if (this.eq2_b_radio.isSelected()) {
				for (int b = eq2_bFrom; b < eq2_bTo + 1; b++) {
					myParser.addVariable("b", (double) b);
					result = myParser.getValueAsObject();
					graph.parseEQ2Result(result);
				}
			} else {
				result = myParser.getValueAsObject();
				graph.parseEQ2Result(result);
			}
		}
	}

	public void parseEQ1() {
		Object result;
		int eq1_bFrom = 0;
		int eq1_bTo = 0;
		if (eqn1_expression.getText() == "") {// if no equation entered, go
												// back
			return;
		}
		if (eq1_b_radio.isSelected()) {
			myParser.addVariable("b", 1); // add b to parser..
			eq1_bFrom = Integer.parseInt(this.eq1_b_from.getText());
			eq1_bTo = Integer.parseInt(this.eq1_b_to.getText());
		}
		myParser.parseExpression(eqn1_expression.getText());

		for (int a = 1; a < graph.getNodeCount(); a++) {
			myParser.addVariable("x", (double) a);
			if (this.eq1_b_radio.isSelected()) {
				for (int b = eq1_bFrom; b < eq1_bTo + 1; b++) {
					myParser.addVariable("b", (double) b);
					result = myParser.getValueAsObject();
					graph.parseEQ1Result(result);
				}
			} else {
				result = myParser.getValueAsObject();
				graph.parseEQ1Result(result);
			}
		}
	}

	public void addActionListeners() {
		time_inc.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// if(prevStartNum != Integer.parseInt(num_start_at.getText())){
				graph.setStartNum(graph.getStartNum() + 1);
				// }
				num_start_at.setText(String.valueOf(graph.getStartNum() + 1));
				graph.setShowPrimes(primes.isSelected());
				parseExpression();
				// set the previous start num, so we dont have to reset the eq
				// every time t
				prevStartNum = Integer.parseInt(num_start_at.getText());

				repaint();
			}
		});
		eq2ColorButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				graph.setEQ1Color(JColorChooser.showDialog(graph,
						"Choose Expression 2 Color", graph.getEQ2Color()));
				repaint();
			}
		});

		eq1ColorButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				graph.setEQ1Color(JColorChooser.showDialog(graph,
						"Choose Expression 1 Color", graph.getEQ1Color()));
				repaint();
			}
		});

		zoomIn.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				graph.setShowPrimes(primes.isSelected());

				setZoom(false);
			}
		});
		zoomOut.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				graph.setShowPrimes(primes.isSelected());

				setZoom(true);
			}
		});

		ComputeButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (prevStartNum != Integer.parseInt(num_start_at.getText())) {
					graph.setStartNum(Integer.parseInt(num_start_at.getText()));
				}

				graph.setShowPrimes(primes.isSelected());
				parseExpression();
				// set the previous start num, so we dont have to reset the eq
				// every time t
				prevStartNum = Integer.parseInt(num_start_at.getText());
				repaint();
			}
		});

		resetButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				graph.resetGraph();
				repaint();
			}
		});

	}
}
